/*
 * blanco Framework
 * Copyright (C) 2004-2006 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.db.expander.query.iterator;

import java.util.List;

import blanco.cg.BlancoCgObjectFactory;
import blanco.cg.valueobject.BlancoCgClass;
import blanco.cg.valueobject.BlancoCgMethod;
import blanco.cg.valueobject.BlancoCgSourceFile;
import blanco.db.common.expander.BlancoDbAbstractMethod;
import blanco.db.common.valueobject.BlancoDbSetting;
import blanco.db.common.valueobject.BlancoDbSqlInfoStructure;
import blanco.db.util.BlancoDbCgUtilDotNet;

/**
 * 個別のメソッドを展開するためのクラス。
 * 
 * @author Tosiki Iga
 */
public class GetListMethodDotNet extends BlancoDbAbstractMethod {
    public GetListMethodDotNet(final BlancoDbSetting argDbSetting,
            final BlancoDbSqlInfoStructure argSqlInfo,
            final BlancoCgObjectFactory argCgFactory,
            final BlancoCgSourceFile argCgSourceFile,
            final BlancoCgClass argCgClass) {
        super(argDbSetting, argSqlInfo, argCgFactory, argCgSourceFile,
                argCgClass);
    }

    public void expand() {
        final BlancoCgMethod cgMethod = fCgFactory.createMethod("GetList",
                "検索結果をリストで取得します。");
        fCgClass.getMethodList().add(cgMethod);

        cgMethod.setReturn(fCgFactory.createReturn(
                "System.Collections.ArrayList", fSqlInfo.getName()
                        + "クラスのList。検索結果が0件の場合には空のリスト。"));

        BlancoDbCgUtilDotNet.addExceptionToMethodSqlException(fCgFactory,
                cgMethod);

        final List<String> listDesc = cgMethod.getLangDoc()
                .getDescriptionList();
        listDesc.add("リストには " + fSqlInfo.getName() + "クラスが格納されます。");
        // listDesc.add("検索結果の件数があらかじめわかっていて、且つ件数が少ない場合に利用することができます。");
        // listDesc.add("検索結果の件数が多い場合には、このメソッドは利用せず、代わりに
        // next()メソッドを利用することをお勧めします。");

        cgMethod.getParameterList().add(
                fCgFactory.createParameter("size", "int", "読み出しを行う行数。"));

        final List<String> listLine = cgMethod.getLineList();

        listLine.add("ArrayList result = new ArrayList(size);");
        listLine.add("for (int count = 1; count <= size; count++) {");
        listLine.add("if (Next() == false) {");
        listLine.add("break;");
        listLine.add("}");
        listLine.add("result.Add(GetRow());");
        listLine.add("}");
        listLine.add("return result;");
    }
}